/*	wt]xH쎺	J.Sugita	2011/05/27

lcdlib.cAVR-CDCgݍ݂ɗpB
define`̂܂ܕϐ錾ɕύX̂ŕϐ啶炯B
*/

//SUNLIKE [SC1602]												|[SD1602]
//pin:	14	13	12	11	10	9	8	7	6	5	4	3	2	1	|16	15
//bit:	DB7	DB6	DB5	DB4	DB3	DB2	DB1	DB0	E	R/W	RS	Vo	VDD	VSS	|K	A
//		<- 4bit mode ->									+V	GND	|-	+

#include	<avr/io.h>
#include	<util/delay.h>
#include	"lcdlib_cdc.h"
#include	"lcdlib_def.h"

//LCDR}hiPCœ`Ɓj
enum	E_LCDLIB_COMMAND
{
	LCMD_BUF_READY,
	LCMD_BUF_SET,
	LCMD_DATA_PORT,		//(PORTC, DDRC)	o̓WX^,WX^̏
	LCMD_DATA_BIT,		//(0b00111100, 0)	A4bit,rbgo[X(1)^Ȃ(0)
	LCMD_CTRL_PORT,		//(PORTB, DDRB)	o̓WX^,WX^̏
	LCMD_CTRL_BIT,		//(0b00000010, 0b00000001)	E,RS̏
	LCMD_INIT,		//LCDi|[gݒ肵Ɏsj
	LCMD_CMD,		//R}h𔭍s
	LCMD_CHAR,		//1\
	LCMD_STRING,	//8ȉ̕\iLCMD_BUF_XXXƑgݍ킹Ďgj
	LCMD_UINT,		//UInt16^܂UInt8^\
	LCMD_DEFCHAR	//O`m肷iLCMD_BUF_XXXƑgݍ킹Ďgj
};

static	void	lcdCmd(uint8_t data);
#define	lcdCls()		lcdCmd(LCD_CMD_CLEAR_DISPLAY)
#define	lcdSetPos(x, y)	lcdCmd(LCD_CMD_SET_DDRAM_ADRS | ((y) * 0x40 + (x)))

//|[g̃AhX
volatile	uint8_t	*LCD_DATA_PORT, *LCD_DATA_DDR;
volatile	uint8_t	*LCD_CTRL_PORT, *LCD_CTRL_DDR;

//|[g̃rbg̊蓖āi4bit[hOj
#define			LCD_RW	0		//Read/Write		H:read	L:write		gpin[hIwriteŒj
static	uint8_t	LCD_RS = 0;		//Register Select	H:data	L:command
static	uint8_t	LCD_E = 0;		//Enable Signal		H->L:strobe
static	uint8_t	LCD_DATABITS = 0;			//f[^4bit
static	uint8_t	LCD_DATABITS_SHIFT = 0;		//LSB牽rbg߂f[^rbgBFbit3-0Ȃ0Abit7-4Ȃ4
static	uint8_t	LCD_DATABITS_REVERSE = 0;	//f[^4bit̐ڑΉ	0:MSB=DB7`LSB=DB4	1:MSB=DB4`LSB=DB7
static	uint8_t	LCD_NOT_DATABITS = 0, LCD_NOT_CTRLBITS = 0;

//obt@
#define	LCD_BUF_SIZE	(16 + 1)	//16+kI[
static	uint8_t	lcdbuf[LCD_BUF_SIZE] = {0};
static	uint8_t	bidx = 0;

//obt@
static	void	lcdBufInit()
{
	uint8_t	i;
	for (i = 0; i < LCD_BUF_SIZE; i++) lcdbuf[i] = 0;
	bidx = 0;
}

static	void	lcdBufSet(uint8_t data1, uint8_t data2)
{
	if (bidx < LCD_BUF_SIZE) lcdbuf[bidx++] = data1;
	if (bidx < LCD_BUF_SIZE) lcdbuf[bidx++] = data2;
}

//gp|[g
static	void	lcdSetDataPort(uint8_t portAddr, uint8_t ddrAddr)
{
	LCD_DATA_PORT = (uint8_t *)((uint16_t)portAddr);
	LCD_DATA_DDR = (uint8_t *)((uint16_t)ddrAddr);
}

static	void	lcdSetDataBit(uint8_t fourBits, uint8_t isBitReverse)
{
	LCD_DATABITS = fourBits;
	LCD_NOT_DATABITS = ~LCD_DATABITS;
	LCD_DATABITS_REVERSE = isBitReverse;
	
	for (LCD_DATABITS_SHIFT = 0; LCD_DATABITS_SHIFT < 8; LCD_DATABITS_SHIFT++)
		if (LCD_DATABITS == (0x0F << LCD_DATABITS_SHIFT)) break;
}

static	void	lcdSetCtrlPort(uint8_t portAddr, uint8_t ddrAddr)
{
	LCD_CTRL_PORT = (uint8_t *)((uint16_t)portAddr);
	LCD_CTRL_DDR = (uint8_t *)((uint16_t)ddrAddr);
}

static	void	lcdSetCtrlBit(uint8_t bitE, uint8_t bitRS)
{
	LCD_E = bitE;
	LCD_RS = bitRS;
	
	LCD_NOT_CTRLBITS = ~(LCD_E | LCD_RW | LCD_RS);
}

static	void	lcdBitReset()
{
	*LCD_DATA_PORT &= LCD_NOT_DATABITS;
	*LCD_CTRL_PORT &= LCD_NOT_CTRLBITS;
}

//lcdPutChar()̕⏕֐
static	uint8_t	bitrev(uint8_t data)
{
	//data4bitł邱ƂO	//1234
	return	((data & 0x08) >> 3) |	//0001
			((data & 0x04) >> 1) |	//0021
			((data & 0x02) << 1) |	//0321
			((data & 0x01) << 3);	//4321
}

//lcdCmd()̕⏕֐
static	void	lcdCmd4bit(uint8_t data)
{
	//data4bitł邱ƂO
	if (LCD_DATABITS_REVERSE) data = bitrev(data);
	
	*LCD_DATA_PORT = (*LCD_DATA_PORT & LCD_NOT_DATABITS) | (data << LCD_DATABITS_SHIFT);
	*LCD_CTRL_PORT = (*LCD_CTRL_PORT & LCD_NOT_CTRLBITS) | LCD_E;
	_delay_ms(1);
	*LCD_CTRL_PORT &= ~LCD_E;
	_delay_ms(1);
}

static	void	lcdCmd(uint8_t data)
{
	lcdCmd4bit((data >> 4) & 0x0F);	//4bit
	lcdCmd4bit(data & 0x0F);		//4bit
}

static	void	lcdInit()
{
	*LCD_DATA_DDR |= LCD_DATABITS;
	*LCD_CTRL_DDR |= (LCD_E | LCD_RW | LCD_RS);
	lcdBitReset();
	
	_delay_ms(15);
	lcdCmd4bit(0b0011);
	_delay_ms(5);
	lcdCmd4bit(0b0011);
	_delay_us(100);
	lcdCmd4bit(0b0011);
	
	lcdCmd4bit(0b0010);		//4-bit[hֈڍs
	
	//   bit:76543210
	lcdCmd(0b00101000);		//Function Set	bit:5(1), DL=4-bit(0), N=2lines(1), F=5x8dots(0), *(0), *(0)
	lcdCmd(0b00001000);		//Display Set	bit:3(1), D=Set Display:NO(0), C=Set Cursor:NO(0), B=Cursor Blink:NO(0)
	lcdCmd(0b00000001);		//Clear Display	bit:0(1)
	lcdCmd(0b00000110);		//Entry Mode	bit:2(1), I/D=Increment(1), S=With Display Shift:NO(0)
	lcdCmd(0b00001100);		//Display Set	bit:3(1), D=Set Display:YES(1), C=Set Cursor:NO(0), B=Cursor Blink:NO(0)
}

static	void	lcdPutChar(char c)
{
	char cdata = (c >> 4) & 0x0F;
	if (LCD_DATABITS_REVERSE) cdata = bitrev(cdata);
	
	*LCD_DATA_PORT = (*LCD_DATA_PORT & LCD_NOT_DATABITS) | (cdata << LCD_DATABITS_SHIFT);	//4bit
	*LCD_CTRL_PORT = (*LCD_CTRL_PORT & LCD_NOT_CTRLBITS) | LCD_RS | LCD_E;
	_delay_us(100);
	*LCD_CTRL_PORT &= ~LCD_E;
	_delay_us(100);
	
	cdata = c & 0x0F;
	if (LCD_DATABITS_REVERSE) cdata = bitrev(cdata);
	
	*LCD_DATA_PORT = (*LCD_DATA_PORT & LCD_NOT_DATABITS) | (cdata << LCD_DATABITS_SHIFT);	//4bit
	*LCD_CTRL_PORT = (*LCD_CTRL_PORT & LCD_NOT_CTRLBITS) | LCD_RS | LCD_E;
	_delay_us(100);
	*LCD_CTRL_PORT &= ~LCD_E;
	_delay_us(100);
	
	*LCD_CTRL_PORT &= ~LCD_RS;
	_delay_us(100);
}

static	void	lcdPutStr(const char* s)
{
	while (*s != 0)
	{
		lcdPutChar(*s);
		s++;
	}
}

static	void	lcdPutUInt(uint16_t n)
{
	uint8_t	i = 0;
	//uint8_t	kbuf[5] = {0};	//16bit5
	
	do
	{
		lcdbuf[i++] = n % 10;
		n /= 10;
	}
	while (0 < n);
	
	while (i != 0)
		lcdPutChar('0' + lcdbuf[--i]);
}

static	void	lcdDefChar(uint8_t id, const uint8_t* dots)
{
	//id:	0-7iLN^R[hj
	//dots:	uint8_t[8]i5x8̃hbgp^[j
	uint8_t	i;
	for (i = 0; i < 8; i++)
	{
		lcdCmd(LCD_CMD_SET_CGRAM_ADRS | (id << 3) | i);
		lcdPutChar(dots[i]);
	}
}

void	lcdAction(uint8_t cmd, uint8_t val, uint8_t val2)
{
	switch (cmd)
	{
	case LCMD_BUF_READY:	lcdBufInit();	break;
	case LCMD_BUF_SET:		lcdBufSet(val, val2);	break;
	case LCMD_DATA_PORT:	lcdSetDataPort(val, val2);	break;
	case LCMD_DATA_BIT:		lcdSetDataBit(val, val2);	break;
	case LCMD_CTRL_PORT:	lcdSetCtrlPort(val, val2);	break;
	case LCMD_CTRL_BIT:		lcdSetCtrlBit(val, val2);	break;
	case LCMD_INIT:		lcdInit();	break;
	case LCMD_CMD:		lcdCmd(val);	break;
	case LCMD_CHAR:		lcdPutChar((char)val);	break;
	case LCMD_STRING:	lcdPutStr((char*)lcdbuf);	break;
	case LCMD_UINT:		lcdPutUInt( ((uint16_t)val << 8) | (uint16_t)val2 );	break;
	case LCMD_DEFCHAR:	lcdDefChar(val, lcdbuf);	break;
	default:	break;
	}
}
